/***************************************************************************
 *   Copyright (C) 2006 by Vladimir Mitrovic   *
 *   snipe714@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include <sys/time.h>
#include <iostream.h>

#include "trigen.h"

trigen::trigen() {
	urandom = new QFile("/dev/urandom");
	if (!urandom->open(IO_ReadOnly)) {
		std::cerr << "Nisam mogao da otvorim fajl /dev/urandom !!" << std::endl;
	}
}

trigen::~trigen() {
	urandom->close();
	delete urandom;
}

QChar trigen::getRandomChar(bool vowels) {
	QChar tmp;
	struct timeval tv;
	struct timezone tz;
	
	while (true) {
		gettimeofday(&tv, &tz);
		srand((unsigned int)tv.tv_usec);
		tmp = (QChar)(unsigned char) (65 + rand()%57);
		switch ((char) tmp) {
			case 'A': case 'E': case 'I': case 'O': case 'U': case 'Y':
			case 'a': case 'e': case 'i': case 'o':	case 'u': case 'y':
				if (vowels) return tmp;
				else continue;
				break;
			default:
				if (!vowels && tmp.isLetter()) return tmp;
				else continue;
		}
	}
}

QChar trigen::getRandomDigit() {
	unsigned char digi;
	struct timeval tv;
	struct timezone tz;
	
	gettimeofday(&tv, &tz);
	srand((unsigned int) tv.tv_usec);
	digi = (unsigned char) (48 + rand()%9);
	
	return (QChar)digi;
}

QChar trigen::getURandomChar(bool vowels) {
	QChar tmp;
	
	while (true) {
		tmp = (QChar)(unsigned char) (65 + urandom->getch() % 57);
		switch ((char) tmp) {
			case 'A': case 'E': case 'I': case 'O': case 'U': case 'Y':
			case 'a': case 'e': case 'i': case 'o':	case 'u': case 'y':
				if (vowels) return tmp;
				else continue;
				break;
			default:
				if (!vowels && tmp.isLetter()) return tmp;
				else continue;
		}
	}
}

QChar trigen::getURandomDigit() {
	return (QChar)(unsigned char) (48 + urandom->getch() % 9);
}

QString trigen::generateNext(unsigned int passlen, unsigned int numcnt, bool lowercase, bool urand) {
	bool vowels = false;	/* samoglasnici... */
	QString the_password;

	unsigned int i;
	for (i = 0; i < passlen - numcnt; i++) {
		the_password[i] = (urand ? getURandomChar(vowels) : getRandomChar(vowels));
		if (lowercase) 
			the_password[i] = the_password[i].lower();
		vowels = !vowels;
	}
	for (; i < passlen; i++) {
		the_password[i] = (urand ? getURandomDigit() : getRandomDigit());
	}
	
	return the_password;
}
